"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("@beenotung/tslib/fs");
var fs = require("fs");
var path = require("path");
var ts = require("typescript");
function scanSync(entryPath, ext) {
    return fs_1.scanRecursivelySync({
        entryPath: entryPath,
        dereferenceSymbolicLinks: true,
        skipDir: function (dirname, basename) {
            return basename === 'node_modules' && dirname.includes('node_modules');
        },
        onFile: function (inFilename, inBasename) {
            if (!inBasename.endsWith('.macro.ts')) {
                return;
            }
            console.log('expanding', inFilename);
            var outBasename = inBasename.replace(/\.macro\.ts$/, ext);
            var outFilename = path.join(path.dirname(inFilename), outBasename);
            var inText = fs.readFileSync(inFilename).toString();
            /* tslint:disable-next-line no-eval */
            var outText = eval(ts.transpile(inText));
            fs.writeFileSync(outFilename, outText);
        },
    });
}
exports.scanSync = scanSync;
//# sourceMappingURL=scanner.js.map